config/routes.rb
Rails.application.routes.draw do


  root to: "home#index"

  # Devise
  devise_for :users, controllers: { registrations: 'users/registrations' }
  
  # Users
  resources :users, only: [:index, :show, :edit, :update] do
    resources :follows, only: [:index, :create, :destroy]
    resources :bookmarks, only: [:index, :create, :destroy]
  end
  
  # Articles
  resources :articles do
    collection do 
      get :my
    end
    
    # Alternatives
    resources :alternatives, shallow: true do
      collection do
        post :update_all
      end
    end

    # Criteria
    resources :criteria, only: [:index]

    # Ratings
    resources :ratings, only: [:index]

    # Members
    resources :members, shallow: true do
      collection do
        get :new_request
      end
      member do
        get :approval
      end
    end
  end

  # Results
  get '/articles/:article_id/results' => 'results#index', as: :article_results
  get '/articles/:article_id/chart'   => 'results#chart', as: :article_chart

  # Visualization
  get '/articles/:article_id/viz'     => 'viz#index',    as: :article_viz
  get '/articles/:article_id/sankey'  => 'viz#sankey',   as: :article_sankey

  # Sensitivity Analysis 
  get '/articles/:article_id/sensitivity' => 'sensitivity#index',  as: :article_sensitivity
  get '/articles/:article_id/sensitivity_data' => 'sensitivity#data',  as: :article_sensitivity_data

  # Appraisal
  resources :appraisals, only: :destroy
  
  resources :criteria, only: [:show, :edit, :update, :destroy] do
    member do
      get :tree
      get 'new' => :new, as: :new
      post '' => :create, as: :create_sub
    end
    
    controller :direct_comparisons do
      get 'direct_comparisons/new'  => :new,    as: :new_direct_comparisons
      get 'direct_comparisons/edit' => :edit,   as: :edit_direct_comparisons
      post 'direct_comparisons'     => :create, as: :direct_comparisons
      patch 'direct_comparisons'    => :update
      put 'direct_comparisons'      => :update
    end

    controller :magiq_comparisons do
      get 'magiq_comparisons/new'  => :new,    as: :new_magiq_comparisons
      get 'magiq_comparisons/edit' => :edit,   as: :edit_magiq_comparisons
      post 'magiq_comparisons'     => :create, as: :magiq_comparisons
      patch 'magiq_comparisons'    => :update
      put 'magiq_comparisons'      => :update
    end

    controller :ahp_comparisons do
      get 'ahp_comparisons/new'  => :new,    as: :new_ahp_comparisons
      get 'ahp_comparisons/edit' => :edit,   as: :edit_ahp_comparisons
      post 'ahp_comparisons'     => :create, as: :ahp_comparisons
      patch 'ahp_comparisons'    => :update
      put 'ahp_comparisons'      => :update
    end

    controller :ratings do
      get 'ratings' => :show, as: :ratings
    end
  end

end

app/controllers/ratings_controller.rb
class RatingsController < ApplicationController
  include TurbolinksCacheControl
  skip_before_action :authenticate_user!

  def index
    @article = Article.find params[:article_id]
    authorize! :read, @article
    @criterion = @article.criteria.root 
    @presenter = CriterionPresenter.new @criterion, current_user, member_id: params[:member_id], article_id: params[:article_id]
  end

  def show
    @criterion = Criterion.includes(:appraisals).find(params[:criterion_id])
    authorize! :read, @criterion.article
    @presenter = CriterionPresenter.new @criterion, current_user, member_id: params[:member_id], article_id: params[:article_id]
    respond_to do |format|
      format.html 
      format.js 
    end
  end

end

app/views/ratings/_ratings_table.html.slim
- criterion = presenter.criterion
.widget
  .widget-header
    i.icon-sitemap
    h3 Alternative ratings
  .well.well-widget-content
    .section
      .widget-content-title Alternative ratings with respect to:
      h3 = criterion.title
      -unless criterion.description.blank?
        blockquote.formatted-output
          = raw(criterion.description)

    - unless presenter.alternatives.exists?
      .alert.alert-info 
        | You need to create some alternatives first. 
        = link_to 'Create now', new_article_alternative_path(presenter.article)
    - else
      .section
        .section-title Alternative scores
        - if presenter.table.nil?
          .alert.alert-info Select one of the comparison methods below to create comparison of the alternatives with respect to this criterion.
        - else
          = render partial: 'criteria/comparison_method', locals: { presenter: presenter }
          table.table.table-condensed.table-bordered.objectives-table
            thead
              tr
                th.narrow No
                th.wide Alternative
                th.number Rank
                - if presenter.comparison_type == 'DirectComparison'
                  th.number Value
                th.number Score
                th Ratio
            tbody
              - presenter.table.each.with_index(1) do |row, idx|
                tr
                  td.narrow = row[:no] || idx
                  td.wide = row[:title]
                  td.number = row[:rank]
                  - if presenter.comparison_type == 'DirectComparison'
                    td.number = row[:value]
                  td.number 
                    div = number_to_percentage((row[:score_n] || 0)*100, precision: 1) || '-'
                  td
                    .progress
                      .bar style="width: #{number_to_percentage((row[:score_n] || 0)*100, precision: 0)}"

      = render partial: 'criteria/toolbar', locals: { presenter: presenter, read_only: false }

app/views/ratings/_sidepanel.html.slim
-if p.root.blank?
  .well.side-widget
    .side-widget-header
    .side-widget-title Criteria Tree
    .side-widget-content
      .alert.alert-error
        p You have not created any criterion.
-else
  .well.side-widget
    .side-widget-header
      a.resize-button data-toggle="collapse" data-target="#widget1" href="#" 
        i.icon-minus
    .side-widget-title Criteria Tree
    #widget1.collapse.in
      .side-widget-content
        = content_tag "div", id: "ratings-tree", data: {node: p.root.id, allow_click: p.allow_navigate, pid: p.member_id} do
          div style="width:90%;"
            = image_tag "ajax-loader.gif"
      .side-widget-toolbar
        = link_to url_for([p.article, :criteria]), class:"btn btn-mini edit-button"
          i.icon-align-justify
        = link_to "Done", "#", class: "btn btn-mini btn-primary done-button", style: "display: none"
        span#add-criterion style="display: none; padding: 5px 0 0 10px"
          a.btn.btn-mini#add-sub href="#"
            ' Add sub-criterion
            i.icon-chevron-right

app/views/ratings/index.html.slim
- page_title "Ratings for #{@article.title}"

= article_menu @article
- content_for :left_frame do
  - if @presenter.criteria.empty?
    .alert.alert-info Please create some criteria first
  - else
    = render partial: 'sidepanel', locals:{ p: @presenter }

#container-box
  = render 'shared/flash_messages'
  .alert.alert-info Select one of the criteria at left to rate the alternatives

app/views/ratings/show.html.slim
- page_title "Ratings for #{@presenter.criterion.title}"

= article_menu @presenter.article
- content_for :left_frame do
  - if @presenter.criteria.empty?
    .alert.alert-info "Please create some criteria first"
  - else
    = render partial: 'sidepanel', locals:{ p: @presenter }

#container-box
  = render 'shared/flash_messages'
  -unless @presenter.root.nil?
    = render partial: 'ratings_table', locals: { alternatives: @alternatives, presenter: @presenter }

app/views/ratings/show.js.erb
$("#container-box").html("<%=j render partial: 'ratings_table', locals: { alternatives: @alternatives, presenter: @presenter } %>");